import { Component, OnInit, Input, Inject, DoCheck } from '@angular/core';
import { Target } from '../../../target/model';
import { MAT_DIALOG_DATA } from '@angular/material';
import { Infra } from '../../../infra/model';
import { MetaCrawler } from '../../../meta/crawler/model/MetaCrawler';
import { MetaSensorDisplayItem } from '../../../meta/sensor-display-item/model/MetaSensorDisplayItem';


@Component({
  selector: 'of-sensor-setting',
  templateUrl: './setting.component.html',
  styleUrls: ['./setting.component.scss']
})
export class SettingComponent implements OnInit, DoCheck {

  selectedTarget: Target = null;
  selectedCrawler: MetaCrawler = null;
  selectedSensorDisplayItems: Set<MetaSensorDisplayItem> = null;
  step = 1;
  nextable = false;

  constructor(
    @Inject(MAT_DIALOG_DATA) public data: any
  ) {
    if (data !== null) {
      this.selectedTarget = data.infra.target;
    }
  }

  ngOnInit() {
  }

  ngDoCheck() {
    if (
      this.selectedTarget === null ||
      this.selectedCrawler === null ||
      this.selectedSensorDisplayItems === null ||
      this.selectedSensorDisplayItems.size === 0
    ) {
      this.nextable = false;
    } else {
      this.nextable = true;
    }
  }

  onNext() {
    this.step += 1;
  }

  onPrev() {
    this.step -= 1;
  }

  onDone() {
    // SensorService.registSensorConfig(Sensor sensor, List<SensorItem> sensorItemList, String etcJson)
  }

  handleTargetSelection(t: Target) {
    this.selectedTarget = t;
  }
  handleCrawlerSelection(c: MetaCrawler) {
    this.selectedCrawler = c;
  }
  handleItemSelection(itemSet: Set<MetaSensorDisplayItem>) {
    this.selectedSensorDisplayItems = itemSet;
  }
}
